; File Name   :	d:\hobby3\bic_gide\vdisc\vdisk.com
; Format      :	Binary file
; Base Address:	0000h Range: 0100h - 0780h Loaded length: 0680h
; Processor	  : z80	[]
; Target assembler: Zilog Macro	Assembler
; Segment type:	Pure code

; reass V. Pohlers 12.03.2021
; Ldt verschiebbaren Treiber vors BDOS
; vgl prl2com, Loader-Teil

;------------------------------------------------------------------------------
; VDISK PRL-Loader
;------------------------------------------------------------------------------

		cpu	z80
		
		org 100h

		jp	start

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

trblen:		dw 477h			; Laenge Treiber
ccpsize:	dw 800h			; Laenge CCP
trbadr:		dw 0			; Adresse Treiber im RAM
srcadr:		dw unk_200		; zu kopierende	Adresse	(Ausgangsadresse)
zieladr:	dw 0			; zu patchende Adresse (Zieladresse)
trbend:		dw 0

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

start:		ld	hl, (6)		; Adresse BDOS
		ld	de, (trblen)	; Laenge Treiber
		xor	a
		sbc	hl, de
		ld	de, (ccpsize)	; Laenge CCP
		sbc	hl, de
		ld	l, 0
		ld	(trbadr), hl	; Adresse Treiber im RAM
		ld	(zieladr), hl	; zu patchende Adresse (Zieladresse)
		ld	d, h
		dec	d
		ld	hl, (trblen)	; Laenge Treiber
		inc	h
		inc	h		; HL+200h(Offset Treiber)
		ld	(trbend), hl
; Treiber verschieben
start1:		ld	hl, (trbend)	; Adresse in Tabelle mit Relokations-Informationen
		ld	b, (hl)		; nchstes Reloc-Byte lesen
		inc	hl		; nchste Adresse
		ld	(trbend), hl	; einstellen
		ld	c, 0		; Bit-Zhler
start2:		ld	hl, (trblen)	; Laenge Treiber
		ld	a, l
		or	h		; alle Bytes kopiert (HL=0)?
		jr	z, trbstart	; dann Treiber starten (auf Startadresse)
		dec	hl		; sonst	ein Byte weniger abzuarbeiten
		ld	(trblen), hl	; Laenge Treiber
		ld	hl, (srcadr)	; aktuelle Adresse
		ld	a, (hl)		; Byte holen
		inc	hl		; nchste Adresse
		ld	(srcadr), hl	; aktuelle Adresse
		rlc	b		; nachstes Bit testen
		jr	nc, start3	; wenn 0, dann nicht patchen
		add	a, d		; sonst	Adress-Offset addieren
start3:		ld	hl, (zieladr)	; zu patchende Adresse (Zieladresse)
		ld	(hl), a		; und Byte speichern
		inc	hl		; nchste Adresse
		ld	(zieladr), hl	; einstellen
		inc	c		; Bit-Zhler erhhen
		ld	a, c
		and	7		; sind 8 Bit abgearbeitet?
		jr	nz, start2	; nein
		jr	start1		; ja
;		
trbstart:	ld	hl, (trbadr)	; Adresse Treiber im RAM
		jp	(hl)

;------------------------------------------------------------------------------
; VDISK-Treiber (vdisk), PRL-Format
;------------------------------------------------------------------------------

		org	200h
unk_200:
		binclude vdisk.prl,100h	; ab Offs. 100h

		end
